Chapter 9 Oracle Examples

9.1 (Oracle 9i and 10g)
SELECT OfferNo, CourseNo, Offering.FacSSN, Faculty.FacSSN, 
       FacFirstName, FacLastName
 FROM Offering LEFT JOIN Faculty 
      ON Offering.FacSSN = Faculty.FacSSN
 WHERE CourseNo LIKE 'IS%'
 /

9.1 (Oracle 8i)
SELECT OfferNo, CourseNo, Offering.FacSSN, Faculty.FacSSN, 
       FacFirstName, FacLastName
 FROM Faculty, Offering
 WHERE Offering.FacSSN = Faculty.FacSSN (+) 
   AND CourseNo LIKE 'IS%'
/

9.2 (Oracle 9i and 10g)
SELECT OfferNo, CourseNo, Offering.FacSSN, Faculty.FacSSN, 
       FacFirstName, FacLastName
 FROM Faculty RIGHT JOIN Offering 
      ON Offering.FacSSN = Faculty.FacSSN
 WHERE CourseNo LIKE 'IS%'
/

9.2 (Oracle 8i only)
SELECT OfferNo, CourseNo, Offering.FacSSN, Faculty.FacSSN, 
       FacFirstName, FacLastName
 FROM Faculty, Offering
 WHERE Faculty.FacSSN (+) = Offering.FacSSN 
   AND CourseNo LIKE 'IS%'
/


9.3 (Oracle 9i and 10g)
SELECT FacSSN, FacFirstName, FacLastName, FacSalary,
       StdSSN, StdFirstName, StdLastName, StdGPA
 FROM Faculty FULL JOIN Student 
      ON Student.StdSSN = Faculty.FacSSN
/

9.4 (Oracle 8i)
SELECT FacSSN, FacFirstName, FacLastName, FacSalary,
       StdSSN, StdFirstName, StdLastName, StdGPA
 FROM Faculty, Student
 WHERE Student.StdSSN = Faculty.FacSSN (+)
		UNION
SELECT FacSSN, FacFirstName, FacLastName, FacSalary,
       StdSSN, StdFirstName, StdLastName, StdGPA
 FROM Faculty, Student
 WHERE Student.StdSSN (+) = Faculty.FacSSN
/

9.5 (Oracle 9i and 10g)
SELECT OfferNo, Offering.CourseNo, OffTerm, CrsDesc,
       Faculty.FacSSN, FacFirstName, FacLastName
 FROM ( Faculty RIGHT JOIN Offering 
      ON Offering.FacSSN = Faculty.FacSSN )
   INNER JOIN Course 
      ON Course.CourseNo = Offering.CourseNo
 WHERE Course.CourseNo LIKE 'IS%' AND OffYear = 2006
/

9.5 (Oracle 8i)
SELECT OfferNo, Offering.CourseNo, OffTerm, CrsDesc,
       Faculty.FacSSN, FacFirstName, FacLastName
 FROM Faculty, Offering, Course
 WHERE Offering.FacSSN = Faculty.FacSSN (+)
   AND Course.CourseNo = Offering.CourseNo
   AND Course.CourseNo LIKE 'IS%' AND OffYear = 2006
/

9.6 (Oracle 9i and 10g)
SELECT DISTINCT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacSSN, FacFirstName,
       FacLastName
 FROM ( ( Faculty RIGHT JOIN Offering 
      ON Offering.FacSSN = Faculty.FacSSN )
	INNER JOIN Course 
      ON Course.CourseNo = Offering.CourseNo )
	INNER JOIN Enrollment 
      ON Offering.OfferNo = Enrollment.OfferNo
 WHERE Offering.CourseNo LIKE 'IS%' AND OffYear = 2006
/

9.6 (Oracle 8i)
SELECT DISTINCT Offering.OfferNo, Offering.CourseNo,
       OffTerm, CrsDesc, Faculty.FacSSN, FacFirstName,
       FacLastName
 FROM Faculty, Offering, Course, Enrollment
 WHERE Offering.FacSSN = Faculty.FacSSN (+)
   AND Course.CourseNo = Offering.CourseNo
 	AND Offering.OfferNo = Enrollment.OfferNo
   AND Course.CourseNo LIKE 'IS%' AND OffYear = 2006
/

9.7
SELECT StdSSN, StdFirstName, StdLastName, StdMajor
 FROM Student
 WHERE Student.StdSSN IN
  ( SELECT StdSSN FROM Enrollment 
     WHERE EnrGrade >= 3.5  )
/

9.8
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM Student INNER JOIN Enrollment 
	   ON Student.StdSSN = Enrollment.StdSSN
 WHERE EnrGrade >= 3.5 AND Enrollment.OfferNo IN
  ( SELECT OfferNo FROM Offering 
     WHERE OffTerm = 'FALL' AND OffYear = 2005 )
/

9.9
SELECT StdFirstName, StdLastName, StdCity, EnrGrade
 FROM Student, Enrollment 
 WHERE Student.StdSSN = Enrollment.StdSSN
   AND EnrGrade >= 3.5 AND Enrollment.OfferNo IN
   ( SELECT OfferNo FROM Offering 
	   WHERE OffTerm = 'FALL' AND OffYear = 2005 
        AND FacSSN IN
	     ( SELECT FacSSN  FROM Faculty 
           WHERE FacFirstName = 'LEONARD' 
             AND FacLastName = 'VINCE' )  )
/

9.10
DELETE FROM Offering
 WHERE Offering.FacSSN IN 
  ( SELECT FacSSN FROM Faculty 
     WHERE FacFirstName = 'LEONARD' 
       AND FacLastName = 'VINCE' )
/

9.12
SELECT FacSSN, FacFirstName, FacLastName, FacDept,
       FacSalary
 FROM Faculty
 WHERE FacSSN NOT IN
  ( SELECT StdSSN FROM Student )
/

9.13 (Oracle 9i and 10g)
SELECT FacSSN, FacFirstName, FacLastName, FacSalary
 FROM Faculty LEFT JOIN Student 
      ON Faculty.FacSSN = Student.StdSSN
 WHERE Student.StdSSN IS NULL
/

9.13 (Oracle 8i)
SELECT FacSSN, FacFirstName, FacLastName, FacSalary
 FROM Faculty, Student
 WHERE Faculty.FacSSN = Student.StdSSN (+) 
   AND Student.StdSSN IS NULL
/

9.14
SELECT FacSSN AS SSN, FacFirstName AS FirstName, 
       FacLastName AS LastName, FacCity AS City, 
       FacState AS State 
 FROM Faculty
      MINUS
SELECT StdSSN AS SSN, StdFirstName AS FirstName,
       StdLastName AS LastName, StdCity AS City,
       StdState AS State 
 FROM Student
/

9.15
SELECT DISTINCT FacSSN, FacFirstName, FacLastName, 
                FacRank
 FROM Faculty, Student
 WHERE Student.StdSSN <> Faculty.FacSSN
/

9.16
SELECT FacSSN, FacFirstName, FacLastName, FacDept,
       FacSalary
 FROM Faculty
 WHERE NOT EXISTS
  ( SELECT * FROM Student
	  WHERE Student.StdSSN = Faculty.FacSSN )
/

9.17
SELECT FacSSN, FacFirstName, FacLastName, FacDept,
       FacSalary
 FROM Faculty
 WHERE 0 = 
  ( SELECT COUNT(*) FROM Student
	  WHERE Student.StdSSN = Faculty.FacSSN )
/

9.18
SELECT DISTINCT Enrollment.StdSSN, StdFirstName,
                StdLastName
 FROM Student, Enrollment, Offering
 WHERE Student.StdSSN = Enrollment.StdSSN 
          AND Enrollment.OfferNo = Offering.OfferNo 
          AND CourseNo LIKE 'IS%' AND OffTerm = 'WINTER'
   AND OffYear = 2006 AND NOT EXISTS
	( SELECT * FROM Enrollment E1, Offering O1
	   WHERE E1.OfferNo = O1.OfferNo 
        AND Enrollment.StdSSN = E1.StdSSN
		AND O1.CourseNo LIKE 'IS%' 
        AND O1.OffYear = 2006
        AND O1.OffTerm = 'WINTER'
  		AND Offering.FacSSN <> O1.FacSSN )
/

9.19
SELECT FacFirstName, FacLastName, FacDept
 FROM Faculty
 WHERE NOT EXISTS
  ( SELECT * FROM Offering
     WHERE Offering.FacSSN = Faculty.FacSSN
	    AND OffTerm = 'WINTER' AND OffYear = 2006 )
/

9.20
SELECT DISTINCT FacLastName, FacFirstName, FacDept
FROM faculty F1, offering O1
WHERE F1.FacSSN = O1.FacSSN 
        AND  OffTerm = 'WINTER' AND OffYear = 2006 
        AND NOT EXISTS
   ( SELECT * FROM Offering O2
     WHERE O2.FacSSN = F1.FacSSN
         AND   (OffTerm <> 'WINTER' OR OffYear <> 2006 ) )
/

9.21
SELECT T.CourseNo, T.CrsDesc, COUNT(*) AS NumOfferings, 
       Avg(T.EnrollCount) AS AvgEnroll
 FROM 
  ( SELECT Course.CourseNo, CrsDesc, 
           Offering.OfferNo, COUNT(*) AS EnrollCount
     FROM Offering, Enrollment, Course
     WHERE Offering.OfferNo = Enrollment.OfferNo
       AND Course.CourseNo = Offering.CourseNo
     GROUP BY Course.CourseNo, CrsDesc, Offering.OfferNo
      ) T    
 GROUP BY T.CourseNo, T.CrsDesc
/

9.22
SELECT Faculty.FacSSN, FacLastName, 
       COUNT(DISTINCT CourseNo) AS NumPreparations 
 FROM Faculty, Offering
 WHERE Faculty.FacSSN = Offering.FacSSN
 GROUP BY Faculty.FacSSN, FacLastName
/

9.23
SELECT T.FacSSN, T.FacLastName, 
       COUNT(*) AS NumPreparations
FROM
 (  SELECT DISTINCT Faculty.FacSSN, FacLastName, CourseNo
      FROM Offering, Faculty
      WHERE Offering.FacSSN = Faculty.FacSSN ) T
 GROUP BY T.FacSSN, T.FacLastName
/

9.24
SELECT StdNo 
 FROM StdClub
 GROUP BY StdNo
 HAVING COUNT(*) = ( SELECT COUNT(*) FROM Club )
/

9.25
SELECT StdNo 
 FROM StdClub, Club 
 WHERE StdClub.ClubNo = Club.ClubNo 
   AND CPurpose = 'SOCIAL'
 GROUP BY StdNo
 HAVING COUNT(*) = 
  ( SELECT COUNT(*) FROM Club 
    WHERE CPurpose = 'SOCIAL' )
/

9.26
SELECT Student1.StdNo, SName 
 FROM StdClub, Club, Student1
 WHERE StdClub.ClubNo = Club.ClubNo 
   AND Student1.StdNo = StdClub.StdNo
   AND CPurpose = 'SOCIAL'
 GROUP BY Student1.StdNo, SName
 HAVING COUNT(*) = 
  ( SELECT COUNT(*) FROM Club 
     WHERE CPurpose = 'SOCIAL' )
/

9.27
SELECT ClubNo 
 FROM StdClub, Student1
 WHERE Student1.StdNo = StdClub.StdNo 
   AND SCity = 'SEATTLE'
 GROUP BY ClubNo
 HAVING COUNT(*) = 
  ( SELECT COUNT(*) FROM Student1 
     WHERE SCity = 'SEATTLE' )
/

9.28
SELECT Faculty.FacSSN, FacFirstName, FacLastName 
 FROM Faculty, Offering
 WHERE Faculty.FacSSN = Offering.FacSSN
   AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
   AND OffYear = 2005
 GROUP BY Faculty.FacSSN, FacFirstName, FacLastName
 HAVING COUNT(*) =
  ( SELECT COUNT(*) FROM Offering
    WHERE OffTerm = 'FALL' AND OffYear = 2005 
      AND CourseNo LIKE 'IS%' )
/

9.29
SELECT Faculty.FacSSN, FacFirstName, FacLastName 
 FROM Faculty, Offering
 WHERE Faculty.FacSSN = Offering.FacSSN 
   AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
   AND OffYear = 2005
 GROUP BY Faculty.FacSSN, FacFirstName, FacLastName
 HAVING COUNT(DISTINCT CourseNo) =
  ( SELECT COUNT(DISTINCT CourseNo) FROM Offering
     WHERE OffTerm = 'FALL' AND OffYear = 2005 
       AND CourseNo LIKE 'IS%' )
/

9.31
SELECT Faculty.FacSSN, FacFirstName, FacLastName 
 FROM Faculty, Offering, Enrollment, Student
 WHERE Faculty.FacSSN = Offering.FacSSN 
   AND OffTerm = 'FALL' AND CourseNo LIKE 'IS%'
   AND OffYear = 2005 AND StdClass = 'SR'
   AND Offering.OfferNo = Enrollment.OfferNo
   AND Student.StdSSN = Enrollment.StdSSN
 GROUP BY Faculty.FacSSN, FacFirstName, FacLastName
 HAVING COUNT(DISTINCT Student.StdSSN) =
  ( SELECT COUNT(*) FROM Student 
     WHERE StdClass = 'SR' )
/

9.33
SELECT * 
 FROM Club
 WHERE CBudget > 200 
/

9.34
SELECT * 
 FROM Club
 WHERE CBudget > CActual 
/

9.35
SELECT * 
 FROM Club
 WHERE CBudget <= CActual
/

9.36
SELECT * 
 FROM Club
 WHERE CBudget <= CActual  OR  CActual < 200
/

9.37
SELECT * 
 FROM Club
 WHERE CBudget <= CActual  AND  CActual < 500
/

9.38
SELECT COUNT(*) AS NumRows, 
       COUNT(CBudget) AS NumBudgets 
 FROM Club
/

9.39
SELECT SUM(CBudget) AS SumBudget, 
       SUM(CActual) AS SumActual, 
       SUM(CBudget)-SUM(CActual) AS SumDifference,
       SUM(CBudget-CActual) AS SumOfDifferences
 FROM Club
/

9.40
SELECT FacSSN, COUNT(*) AS NumRows 
 FROM Offering
 GROUP BY FacSSN
/
